<div class="animated fadeIn">
  <div class="row">
    <div class="col-lg-12">
      <div class="card">
        <div class="card-header">
          {{'ddos.application.title' | translate}}
          <span class="float-right"><button
            *ngIf="selectedGroupWebsite"
            [disabled]="add || editStatus" (click)="addDdosRule()" class="btn btn-block btn-primary">{{'common.add' | translate}}</button></span>
        </div>
        <div class="card-body">
          <div class="row justify-content-between mb-2">
            <div class="col-lg-5 col-md-6 col-sm-5">
              <span class="float-left pr-3 show-entity-per-page-label">{{'common.show' | translate}}</span>
              <select (change)="onSearch()" [(ngModel)]="paging.limit" class="form-control float-left"
                      style="max-width: 70px">
                <option *ngFor="let i of PAGING_PER_PAGE" value="{{i.value}}">{{i.label}}</option>
              </select>
            </div>
            <div class="col-lg-5 col-md-4 col-sm-5">
              <div class="float-right" style="min-width: 350px">
                <span class="float-left pr-3 show-entity-per-page-label">{{'ddos.application.group_website' | translate}}</span>
                <select (change)="changeGroupWebsite()" [(ngModel)]="selectedGroupWebsite"
                        class="form-control float-left"
                        [disabled]="editStatus"
                        style="max-width: 200px">
                  <option [ngValue]="null">All</option>
                  <option *ngFor="let website of groupWebsite" [ngValue]="website">{{website.name}}</option>
                </select>
              </div>
            </div>
            <div class="col-2">
              <div class="input-group float-right">
                <input [(ngModel)]="keywordSearch" type="text" class="form-control"
                       placeholder="{{'common.search' | translate}}">
                <div class="input-group-append">
                  <button (click)="onSearch()" class="btn btn-dark" type="button">
                    <i class="fa fa-search"></i>
                  </button>
                </div>
              </div>
            </div>
          </div>
          <table class="table table-bordered table-sort-icon">
            <thead>
            <tr appSort [(orderBy)]="order.orderBy" [(orderType)]="order.orderType" (orderChange)="changeOder($event)">
              <th appSortBy="name" class="text-center">{{'ddos.application.name' | translate}}
                <fa-icon></fa-icon>
              </th>
              <th class="text-center">
                <div class="row">
                  <div class="col">{{'ddos.application.count' | translate}}</div>
                  <div class="col">{{'ddos.application.time' | translate}}</div>
                </div>
              </th>
              <th class="text-center">{{'ddos.application.blockTime' | translate}}</th>
              <th class="text-center">{{'ddos.application.website' | translate}}</th>
              <th class="text-center">{{'ddos.application.url' | translate}}</th>
              <th class="text-center">{{'ddos.application.status' | translate}}</th>
              <th class="text-center">{{'ddos.application.active' | translate}}</th>
              <th class="text-center" style="width: 125px">{{'ddos.application.rule_type' | translate}}</th>
              <th class="text-center">{{'ddos.application.action' | translate}}</th>
            </tr>
            </thead>
            <tbody>
            <!--            view-->
            <tr *ngFor="let ddos of ddosRules; let i = index" [formGroup]="ddosForm">
              <td *ngIf="!editing[i]">{{ddos.name}}</td>
              <td class="text-center" *ngIf="!editing[i]">
                <div class="row">
                  <div class="col">{{ddos.count}}</div>
                  <div class="col">{{ddos.time}}</div>
                </div>
              </td>
              <td class="text-right" *ngIf="!editing[i]">{{ddos.block_time}}</td>
              <!--website -->
              <td class="text-center" *ngIf="!editing[i]">
                <span (click)="distableShow(ddosRules);ddos.isShowWebsite = !ddos.isShowWebsite"><i
                  class="icon-list"></i></span>
                <div class="_tooltip tooltip__initiator text-left" *ngIf="ddos.websites && ddos.isShowWebsite">
                  <div class="tooltip__item">
                    <div class="card m-0">
                      <div class="card-header">
                        <button type="button" class="close" aria-label="Close"
                                (click)="ddos.isShowWebsite = !ddos.isShowWebsite">
                          <i class="fa fa-times" style="color: yellow"></i>
                        </button>
                      </div>
                      <div class="card-body">
                        <div class="row justify-content-between mb-2">
                          <div class="col-6">
                          </div>
                          <div class="col-6">
                            <div class="input-group float-right">
                              <input [(ngModel)]="websiteSearch"
                                     [ngModelOptions]="{standalone: true}"
                                     type="text" class="form-control"
                                     placeholder="{{'common.search' | translate}}" (keyup.enter)="searchWebsite()">
                              <div class="input-group-append">
                                <button (click)="searchWebsite()" class="btn btn-dark" type="button">
                                  <i class="fa fa-search"></i>
                                </button>
                              </div>
                            </div>
                          </div>
                        </div>
                        <table class="table table-bordered">
                          <thead>
                          <tr>
                            <th class="text-center">{{'ddos.application.name' | translate}}</th>

                          </tr>
                          </thead>
                          <tbody>
                          <tr *ngFor="let website of ddos.websites; let i = index">
                            <td>
                              {{website.website}}
                            </td>
                          </tr>
                          </tbody>
                        </table>
                      </div>
                    </div>
                  </div>
                </div>

              </td>
              <td class="text-center" *ngIf="!editing[i]">
                <!--url -->
                <span (click)="distableShow(ddosRules);ddos.isShowUrl = !ddos.isShowUrl"><i
                  class="icon-list"></i></span>
                <div class="_tooltip tooltip__initiator text-left" *ngIf="ddos.isShowUrl">
                  <div class="tooltip__item" style="width: 400px">
                    <div class="card m-0">
                      <div class="card-header">
                        <button type="button" class="close" aria-label="Close"
                                (click)="ddos.isShowUrl = !ddos.isShowUrl">
                          <i class="fa fa-times" style="color: yellow"></i>
                        </button>
                      </div>
                      <div class="card-body">
                        <table class="table table-bordered">
                          <thead>
                          <tr>
                            <th class="text-center">URI</th>
                          </tr>
                          </thead>
                          <tbody>
                          <tr *ngFor="let url of ddos.urls; let i = index">
                            <td>
                              {{url.uri}}
                            </td>
                          </tr>
                          </tbody>
                        </table>
                      </div>
                    </div>
                  </div>
                </div>
              </td>
              <!--status -->
              <td class="text-center" *ngIf="!editing[i]">
                {{ddos.status}}
              </td>
              <td class="text-center" *ngIf="!editing[i]">
                <span>
                  <i [ngClass]="ddos.active ? 'icon-arrow-up-circle large-icons' : 'icon-arrow-down-circle large-icons'"
                     class="font-2xl"
                     [style.color]="ddos.active ? 'green': ''"
                  ></i>
                </span>
              </td>
              <!--rule type -->
              <td class="text-center" *ngIf="!editing[i]">
                {{ddos.rule_type}}
              </td>
              <td class="text-center" *ngIf="!editing[i]">
                <div class="btn-group">
                  <button type="button"
                          class="btn btn-success btn-sm"
                          [disabled]="add || editStatus"
                          (click)="changeEditStatus(i)">
                    <i class="icon-pencil"></i>
                    <span class="d-none d-md-inline">{{'common.edit' | translate}}</span>
                  </button>
                  <button type="button" (click)="delete(deleteModal, i)"
                          class="btn btn-danger btn-sm" [disabled]="add || editStatus">
                    <i class="icon-trash"></i>
                    <span class="d-none d-md-inline">{{'common.delete' | translate}}</span>
                  </button>
                </div>
              </td>

              <!--              edit-->
              <td *ngIf="editing[i]">
                <input class="form-control" [placeholder]="'name' | translate" type="text" formControlName="name">
              </td>
              <td *ngIf="editing[i]">
                <div class="row">
                  <div class="col">
                    <input class="form-control" [placeholder]="'count' | translate" type="number"
                           formControlName="count">
                  </div>
                  <div class="col">
                    <input class="form-control" [placeholder]="'time' | translate" type="number" formControlName="time">
                  </div>
                </div>
              </td>
              <td *ngIf="editing[i]">
                <input class="form-control" [placeholder]="'block time' | translate" type="number"
                       formControlName="block_time">
              </td>

              <td *ngIf="editing[i]" class="text-center">
                <span (click)="distableShow(ddosRules);websiteTooltip = !websiteTooltip"><i
                  class="icon-list"></i></span>
                <div class="_tooltip tooltip__initiator text-left" *ngIf="websiteTooltip">
                  <div class="tooltip__item">
                    <div class="card m-0">
                      <div class="card-header">
                        <button type="button" class="close" aria-label="Close"
                                (click)="websiteTooltip = !websiteTooltip">
                          <i class="fa fa-times" style="color: yellow"></i>
                        </button>
                      </div>
                      <div class="card-body">
                        <div class="row justify-content-between mb-2">
                          <div class="col-6">
                            <div class="row">
                              <div class="col-4">
                                <button class="btn btn-primary" (click)="tickAllWebsite(websites)">Tick All</button>
                              </div>
                              <div class="col-4">
                                <button class="btn btn-secondary" (click)="unTickAllWebsite()">Clear All</button>
                              </div>
                            </div>
                          </div>
                          <div class="col-6">
                            <div class="input-group float-right">
                              <input [(ngModel)]="websiteSearch"
                                     [ngModelOptions]="{standalone: true}"
                                     type="text" class="form-control"
                                     placeholder="{{'common.search' | translate}}" (keyup.enter)="searchWebsite()">
                              <div class="input-group-append">
                                <button (click)="searchWebsite()" class="btn btn-dark" type="button">
                                  <i class="fa fa-search"></i>
                                </button>
                              </div>
                            </div>
                          </div>
                        </div>
                        <table class="table table-bordered">
                          <thead>
                          <tr>
                            <th class="text-center">{{'common.name' | translate}}</th>
                            <th class="text-center">{{'common.action' | translate}}</th>
                          </tr>
                          </thead>
                          <tbody>
                          <tr *ngFor="let website of websites; let i = index">
                            <td>
                              {{website.website_domain}}
                            </td>
                            <td class="text-center">
                              <input type="checkbox" class="custom-checkbox" [checked]="checkTick(website)"
                                     (click)="selectWebsite($event, website)">
                            </td>
                          </tr>
                          </tbody>
                        </table>
                      </div>
                    </div>
                  </div>
                </div>
              </td>
              <td *ngIf="editing[i]" class="text-center">
                <span (click)="distableShow(ddosRules);urlTooltip = !urlTooltip"><i class="icon-list"></i></span>
                <div class="_tooltip tooltip__initiator text-left" *ngIf="urlTooltip">
                  <div class="tooltip__item" style="width: 400px">
                    <div class="card m-0">
                      <div class="card-header">
                        <button type="button" class="close" aria-label="Close" (click)="urlTooltip = !urlTooltip">
                          <i class="fa fa-times" style="color: yellow"></i>
                        </button>
                      </div>
                      <div class="card-body">
                        <div class="row justify-content-between mb-2">
                          <div class="col-8">
                            <div class="input-group float-left">
                              <div class="input-group-prepend">
                                <span class="btn btn-secondary">URI</span>
                              </div>
                              <input [(ngModel)]="newUri"
                                     [ngModelOptions]="{standalone: true}"
                                     type="text" class="form-control"
                                     placeholder="/test"
                              >
                            </div>
                            <span class="text-danger" *ngIf="validateAddUri(ddosForm.controls['urls'])">{{'monitor.ddos.duplicate_uri' | translate}}</span>
                          </div>
                          <div class="col-4">
                            <button class="btn btn-primary float-right"
                                    [disabled]="validateAddUri(ddosForm.controls['urls'])"
                                    (click)="addUri(ddosForm.controls['urls'])">
                              {{'common.add' | translate}}
                            </button>
                          </div>
                        </div>
                        <table class="table table-borderless">
                          <thead>
                          <tr>
                            <th class="text-center">URI</th>
                            <th class="text-center">Action</th>
                          </tr>
                          </thead>
                          <tbody>
                          <tr *ngFor="let url of ddosForm.controls['urls'].value; let i = index">
                            <td>
                              {{url.uri}}
                            </td>
                            <td class="text-center">
                              <i class="icon-trash" style="color: red"
                                 (click)="deleteUri(ddosForm.controls['urls'],i)"></i>
                            </td>
                          </tr>
                          </tbody>
                        </table>
                      </div>
                    </div>
                  </div>
                </div>
              </td>

              <td *ngIf="editing[i]" class="text-center">
                <select formControlName="status" class="form-control float-left">
                  <ng-container *ngFor="let status of statusOptions">
                    <option value="{{status.value}}">
                      {{ status.name }}
                    </option>
                  </ng-container>
                </select>
              </td>
              <td *ngIf="editing[i]" class="text-center">
                <span (click)="changeActiveStatus()">
                  <i
                    [ngClass]="ddosForm.value.active ? 'icon-arrow-up-circle large-icons' : 'icon-arrow-down-circle large-icons'"
                    class="font-2xl"
                    [style.color]="ddosForm.value.active ? 'green': ''"
                  ></i>
                </span>
              </td>
              <!--rule type -->
              <td *ngIf="editing[i]" class="text-center">
                <select formControlName="rule_type" class="form-control">
                  <option *ngFor="let rule_type of rule_types | keyvalue" [value]="rule_type.value">{{rule_type.value}}</option>
                </select>
              </td>

              <td *ngIf="editing[i]" class="text-center">
                <div class="btn-group">
                  <button (click)="editSave(i)"
                          class="btn btn-primary btn-sm">
                    <i class="fa fa-save"></i>
                    <span class="d-none d-md-inline">{{'common.save' | translate}}</span>
                  </button>
                  <button type="button" (click)="editCancel(i)"
                          class="btn btn-danger btn-sm">
                    <i class="icon-action-undo"></i>
                    <span class="d-none d-md-inline">{{'common.cancel' | translate}}</span>
                  </button>
                </div>
              </td>
            </tr>

            <!--add new-->
            <tr *ngIf="add" [formGroup]="ddosForm">
              <td>
                <input class="form-control" [placeholder]="'name' | translate" type="text" formControlName="name">
              </td>
              <td>
                <div class="row">
                  <div class="col">
                    <input class="form-control" [placeholder]="'count' | translate" type="number"
                           formControlName="count">
                  </div>
                  <div class="col">
                    <input class="form-control" [placeholder]="'time' | translate" type="number" formControlName="time">
                  </div>
                </div>
              </td>
              <td>
                <input class="form-control" [placeholder]="'block time' | translate" type="number"
                       formControlName="block_time">
              </td>
              <!-- website tooltip -->
              <td class="text-center">
                <span (click)="distableShow(ddosRules);websiteTooltip = !websiteTooltip;"><i
                  class="icon-list"></i></span>
                <div class="_tooltip tooltip__initiator text-left" *ngIf="websiteTooltip">
                  <div class="tooltip__item">
                    <div class="card m-0">
                      <div class="card-header">
                        <button type="button" class="close" aria-label="Close"
                                (click)="websiteTooltip = !websiteTooltip">
                          <i class="fa fa-times" style="color: yellow"></i>
                        </button>
                      </div>
                      <div class="card-body">
                        <div class="row justify-content-between mb-2">
                          <div class="col-6">
                            <div class="row">
                              <div class="col-4">
                                <button class="btn btn-primary" (click)="tickAllWebsite(selectedGroupWebsite.websites)">
                                  Tick All
                                </button>
                              </div>
                              <div class="col-4">
                                <button class="btn btn-secondary" (click)="unTickAllWebsite()">Clear All</button>
                              </div>
                            </div>
                          </div>
                          <div class="col-6">
                            <div class="input-group float-right">
                              <input [(ngModel)]="websiteSearch"
                                     [ngModelOptions]="{standalone: true}"
                                     type="text" class="form-control"
                                     placeholder="{{'common.search' | translate}}" (keyup.enter)="searchWebsite()">
                              <div class="input-group-append">
                                <button (click)="searchWebsite()" class="btn btn-dark" type="button">
                                  <i class="fa fa-search"></i>
                                </button>
                              </div>
                            </div>
                          </div>
                        </div>
                        <table class="table table-bordered">
                          <thead>
                          <tr>
                            <th class="text-center">Name</th>
                            <th class="text-center">Action</th>
                          </tr>
                          </thead>
                          <tbody>
                          <tr *ngFor="let website of selectedGroupWebsite.websites; let i = index">
                            <td>
                              {{website.website_domain}}
                            </td>
                            <td class="text-center">
                              <input type="checkbox" class="custom-checkbox" [checked]="checkTick(website)"
                                     (click)="selectWebsite($event, website)">
                            </td>
                          </tr>
                          </tbody>
                        </table>
                      </div>
                    </div>
                  </div>
                </div>
              </td>
              <!--url edit -->
              <td class="text-center">
                <span (click)="distableShow(ddosRules);urlTooltip = !urlTooltip;"><i class="icon-list"></i></span>
                <div class="_tooltip tooltip__initiator text-left" *ngIf="urlTooltip">
                  <div class="tooltip__item" style="width: 400px">
                    <div class="card m-0">
                      <div class="card-header">
                        <button type="button" class="close" aria-label="Close" (click)="urlTooltip = !urlTooltip">
                          <i class="fa fa-times" style="color: yellow"></i>
                        </button>
                      </div>
                      <div class="card-body">
                        <div class="row justify-content-between mb-2">
                          <div class="col-8">
                            <div class="input-group float-left">
                              <div class="input-group-prepend">
                                <span class="btn btn-secondary">URI</span>
                              </div>
                              <input
                                [(ngModel)]="newUri"
                                [ngModelOptions]="{standalone: true}"
                                type="text" class="form-control"
                                placeholder="/test">
                            </div>
                            <span class="text-danger" *ngIf="validateAddUri(ddosForm.controls['urls'])">{{'monitor.ddos.duplicate_uri' | translate}}</span>
                          </div>
                          <div class="col-4">
                            <button class="btn btn-primary float-right" [disabled]="validateAddUri(ddosForm.controls['urls'])" (click)="addUri(ddosForm.controls['urls'])">
                              {{'common.add' | translate}}
                            </button>
                          </div>
                        </div>
                        <table class="table table-borderless">
                          <thead>
                          <tr>
                            <th class="text-center">URI</th>
                            <th class="text-center">Action</th>
                          </tr>
                          </thead>
                          <tbody>
                          <tr *ngFor="let url of ddosForm.controls['urls'].value; let i = index">
                            <td>
                              {{url.uri}}
                            </td>
                            <td class="text-center">
                              <i class="icon-trash" style="color: red"
                                 (click)="deleteUri(ddosForm.controls['urls'],i)"></i>
                            </td>
                          </tr>
                          </tbody>
                        </table>
                      </div>
                    </div>
                  </div>
                </div>
              </td>

              <td class="text-center">
                <select formControlName="status" class="form-control float-left">
                  <ng-container *ngFor="let status of statusOptions">
                    <option value="{{status.value}}">
                      {{ status.name }}
                    </option>
                  </ng-container>
                </select>
              </td>
              <td class="text-center">
                <span (click)="changeActiveStatus()">
                  <i
                    [ngClass]="ddosForm.value.active ? 'fa fa-2 fa-arrow-circle-o-up' : 'fa fa-2 fa-arrow-circle-o-down'"
                    class="font-2xl"
                    [style.color]="ddosForm.value.active ? 'green': ''"
                  ></i>
                </span>
              </td>
              <!--rule type -->
              <td class="text-center">
                <select class="form-control" formControlName="rule_type">
                  <option *ngFor="let rule_type of rule_types | keyvalue" [value]="rule_type.value">{{rule_type.value}}</option>
                </select>
              </td>
              <td class="text-center">
                <div class="btn-group">
                  <button (click)="save()"
                          class="btn btn-primary btn-sm">
                    <i class="fa fa-save"></i>
                    <span class="d-none d-md-inline">{{'common.save' | translate}}</span>
                  </button>
                  <button type="button" (click)="add = !add"
                          class="btn btn-danger btn-sm">
                    <i class="icon-action-undo"></i>
                    <span class="d-none d-md-inline">{{'common.cancel' | translate}}</span>
                  </button>
                </div>
              </td>
            </tr>
            </tbody>
          </table>
          <div class="row justify-content-between" *ngIf="ddosRules?.length > 0">
            <span *ngIf="ddosRules.length !== 0" class="col-6">{{'common.pagingInfo' | translate : {
              start: paging.offset + 1,
              end: (paging.offset + ddosRules.length),
              total: paging.total
            } }}</span>

            <div class="col-6">
              <ngb-pagination *ngIf="ddosRules.length !== 0" class="float-right" [boundaryLinks]="true"
                              [collectionSize]="paging.total"
                              [pageSize]="paging.limit" [maxSize]="5" [rotate]="true" [(page)]="paging.page"
                              (pageChange)="loadPage(paging.page)">
              </ngb-pagination>
            </div>
          </div>
          <div *ngIf="ddosRules.length === 0" class="text-center">
            <span>There is no record!</span>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>
<ng-template #deleteModal let-modal>
  <div class="modal-header">
    <h4 class="modal-title" id="modal-comfirm-delete-title">{{'ddos.application.delete_popup.title' | translate}}</h4>
    <button type="button" class="close" aria-label="Close" (click)="modal.dismiss('Cross click')">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    {{'ddos.application.delete_popup.message' | translate: {name : selectedddos.name} }}
  </div>
  <div class="modal-footer">
    <button type="button" class="btn btn-danger" (click)="modal.close('delete')">{{'common.delete' | translate}}
    </button>
    <button type="button" class="btn btn-secondary" (click)="modal.close('Close')">{{'common.close' | translate}}
    </button>
  </div>
</ng-template>

